<?php

class hosting_renewals_license_4333PDOWrapper
{
	static private $pdoConnection;

	static private function getDbConnection()
	{
		if (class_exists('Illuminate\\Database\\Capsule\\Manager')) {
			return \Illuminate\Database\Capsule\Manager::connection()->getPdo();
		}

		if (self::$pdoConnection === NULL) {
			self::$pdoConnection = self::setNewConnection();
		}

		return self::$pdoConnection;
	}

	static private function setNewConnection()
	{
		try {
			$includePath = ROOTDIR . DIRECTORY_SEPARATOR . 'configuration.php';

			if (file_exists($includePath)) {
				require $includePath;
			}
			else {
				throw new Exception('No configuration file found');
			}

			$connection = new PDO(sprintf('mysql:host=%s;dbname=%s;port=%s;charset=utf8', $db_host, $db_name, $db_port ? $db_port : 3360), $db_username, $db_password);
			$connection->setAttribute(PDO::ATTR_ERRMODE, PDO::ERRMODE_EXCEPTION);
			return $connection;
		}
		catch (PDOException $exc) {
		}
	}

	static public function query($query, $params = array())
	{
		$statement = self::getDbConnection()->prepare($query);
		$statement->execute($params);
		return $statement;
	}

	static public function real_escape_string($string)
	{
		return substr(self::getDbConnection()->quote($string), 1, -1);
	}

	static public function fetch_assoc($query)
	{
		return $query->fetch(PDO::FETCH_ASSOC);
	}

	static public function fetch_array($query)
	{
		return $query->fetch(PDO::FETCH_BOTH);
	}

	static public function fetch_object($query)
	{
		return $query->fetch(PDO::FETCH_OBJ);
	}

	static public function num_rows($query)
	{
		$query->fetch(PDO::FETCH_BOTH);
		return $query->rowCount();
	}

	static public function insert_id()
	{
		return self::getDbConnection()->lastInsertId();
	}

	static public function errorInfo()
	{
		$tmpErr = self::getDbConnection()->errorInfo();
		if ($tmpErr[0] && $tmpErr[0] !== '00000') {
			return $tmpErr;
		}

		return false;
	}

	static public function mysql_get_array($query, $params = array())
	{
		$qRes = self::query($query, $params);
		$arr = array();

		while ($row = self::fetch_assoc($qRes)) {
			$arr[] = $row;
		}

		return $arr;
	}

	static public function mysql_get_row($query, $params = array())
	{
		$qRes = self::query($query, $params);
		return self::fetch_assoc($qRes);
	}
}

function hosting_renewals_license_4333()
{

		return array('status' => 'Active', 'description' => 'Your module license is active.');

}

function HostingRenewals_config()
{
	return \ModulesGarden\HostingRenewals\Core\ServiceLocator::call('configurationAddon', 'config');
}

function HostingRenewals_activate()
{
	return \ModulesGarden\HostingRenewals\Core\ServiceLocator::call('configurationAddon', 'activate');
}

function HostingRenewals_deactivate()
{
	return \ModulesGarden\HostingRenewals\Core\ServiceLocator::call('configurationAddon', 'deactivate');
}

function HostingRenewals_upgrade($params)
{
	return \ModulesGarden\HostingRenewals\Core\ServiceLocator::call('configurationAddon')->update(isset($params['version']) ? $params['version'] : '');
}

function HostingRenewals_output($params)
{
	$license_check = hosting_renewals_license_4333();

	if ($license_check['status'] != 'Active') {
		$error_message = isset($license_custom_error_message) ? $license_custom_error_message : 'License ' . $license_check['status'] . ($license_check['description'] ? ': ' . $license_check['description'] : '');
		echo '<strong>License Error: ' . $error_message . '</strong>';
		return $error_message;
	}

	\ModulesGarden\HostingRenewals\Core\ServiceLocator::call('controller')->setParams($params)->execute();
}

function HostingRenewals_clientarea($params)
{
	$license_check = hosting_renewals_license_4333();

	if ($license_check['status'] != 'Active') {
		$error_message = isset($license_custom_error_message) ? $license_custom_error_message : 'License ' . $license_check['status'] . ($license_check['description'] ? ': ' . $license_check['description'] : '');
		echo '<strong>License Error: ' . $error_message . '</strong>';
		return $error_message;
	}

	return \ModulesGarden\HostingRenewals\Core\ServiceLocator::call('clientController')->setParams($params)->execute();
}

require_once __DIR__ . DIRECTORY_SEPARATOR . 'core' . DIRECTORY_SEPARATOR . 'Bootstrap.php';

?>
